
#    Note:  This is loaded into the namespace  LED

#  variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0
    variable allasics 0

   variable ASICList {1 2 3 4}
    variable ASIC [first $ASICList]

    for {set i 0} {$i <= 9} {incr i} {variable Opt90$i 0}




	foreach asic $ASICList {
	    for {set i 1} {$i < 4} {incr i} {
		variable POpts.$asic.Value$i 0
	    }
	    for { set i 0 } { $i < 16 } { incr i } {
		variable POpts.$asic.wave$i 0 
	    }
	}

    variable         POpts.Title1  "Polarity"
    variable         POpts.Title2  "Discriminator Delay (nS)"
    variable         POpts.Title3  "Threshold"
    variable         POpts.Title4  "Channel enable (16->1)"

   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
   }

#1 is the polarity , 2 is the delay and 3 is the threshold value

proc do_POpts { j i vl } {
	variable POpts.$j.$i
	variable ASIC
	variable ASICList
	variable allmodules
	variable allasics

  	set DelayList { 20 40 60 80 100 120 140 160 180 200 220 240 260 280 300 320 }
 	set PolList { Positive Negative }
        set BAK $::AIDA::FEE64
	
	set ASIC $j

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          foreach asic $ASICList {
              if {$allasics == 0 && $asic != $ASIC} continue
		  set curr_reg [ReadAIDARegister [expr 0x900 + ($asic-1)*2 ]]
		  set pol [ expr ( $curr_reg >> 16 ) & 1 ]
		  set thresh [  expr $curr_reg  & 0x3fff ]
		  set delay [ expr ( $curr_reg >> 20 ) & 0xf ]
		
		switch $i { 
			1 { 
				set old_pol $pol				
				set pol [ lsearch $PolList $vl ] 
				if { $pol != $old_pol } {
					set thresh [ expr 16384 - $thresh ]
				}
			}
			2 { set delay [ lsearch $DelayList $vl ] }
			3 { if { $pol == 0 } {
				set thresh [ expr $vl & 0x3fff ] 
			    } else { 
				set thresh [ expr ( 16384 - $vl ) & 0x3fff ]
			    }
			  }
			default { }
		}
	      set local_vl [ expr ( $delay << 20 ) + ( $pol << 16 ) +  $thresh ] 
              WriteAIDARegister [expr 0x900 + (($asic-1)*2) ] $local_vl

          }
      }

      set ::AIDA::FEE64 $BAK

}
   proc do_redisplay {} {
	variable ASICList

     foreach i {0 1 2 3 4 5 6 7 8 9} {
        variable Opt90$i
	if { $i == 7 } {
	    set a [ReadAIDARegister [expr 0x900 + 11]]
            set Opt90$i [ expr $a + 1 ]
	} else {
            set Opt90$i [ReadAIDARegister [expr 0x900 + $i]]
	}
     }

     foreach i {0 1 2 3} {
        variable Opt91$i
        set Opt91$i [ReadAIDARegister [expr 0x910 + $i]]
     }
     foreach asic { 1 2 3 4 } {
		  set curr_reg [ReadAIDARegister [expr 0x900 + ($asic-1)*2 ]]
		  set pol [ expr ( $curr_reg >> 16 ) & 1 ]
		  set thresh [  expr $curr_reg  & 0x3fff ]
		  set delay [ expr ( $curr_reg >> 20 ) & 0xf ]
		  variable POpts.$asic.Value1 $pol
		  variable POpts.$asic.Value2 $delay
		  if { $pol == 1 } {		 
			set thresh [ expr  16384 - $thresh  ]
		  }
		  variable POpts.$asic.Value3 $thresh
     }
     foreach asic { 1 2 3 4 } {
		  set curr_reg [ReadAIDARegister [expr 0x900 + ( $asic * 2 ) - 1 ]]

		  for { set i 0 } { $i < 16 } { incr i } {
		  	variable POpts.$asic.wave$i 
			set  POpts.$asic.wave$i [ expr ( $curr_reg >> $i ) & 1 ]
 		  }

     }
   }

   proc do_setOpt900 {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue
          set ::AIDA::FEE64 $fee64
	if { $i == 7 } {
	  set a [expr $vl - 1 ]
          WriteAIDARegister [expr 0x900 + 11] $a
	} else {
          WriteAIDARegister [expr 0x900 + $i] $vl
	}


      }

      set ::AIDA::FEE64 $BAK   ;#   restore
   }
# this is for enabling/disabling the channels for the waveform collection
   proc do_setWave {i vl} { ;# i is the asic and vl is what to set it to 
      variable allmodules

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
	  set myval [ ReadAIDARegister [expr 0x900 + ( $i * 2 ) - 1] ]
	  set mask [ expr 1 << $vl ]
	  set bit [ expr $myval & $mask ]
	  if { $bit == 0 } { 
		set newval [ expr $myval | $mask ]
#		variable POpts.$i.wave$vl 0 
	  } else {
		set newval [ expr $myval ^ $mask ] ; # should be exor
#		variable POpts.$i.wave$vl 1
	  }
          WriteAIDARegister [expr 0x900 + + ( $i * 2 ) - 1] $newval
      }

      set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc FORCE {} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#  save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0x90a] 0x0
          WriteAIDARegister [expr 0x90a] 0x1    ;#  force waveform capture 
          WriteAIDARegister [expr 0x90a] 0x0
      }

      set ::AIDA::FEE64 $BAK   ;#  restore

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}
                   ALLASICS {variable allasics; set allasics [expr ($allasics + 1) & 1]}

                   OPT900     {do_setOpt900 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   WAVE       {do_setWave [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}

                   POPTS     {do_POpts [second [lindex $cgidata 1]] [third [lindex $cgidata 1]] [fourth [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

    do_redisplay

}   ;# end of if {$started == 0}




